TailFilter (Apache Ant API)
Description: declaration: package: org.apache.tools.ant.filters, class: TailFilter

Package org.apache.tools.ant.filters

# Class TailFilter

java.lang.Object
java.io.Reader
java.io.FilterReader
org.apache.tools.ant.filters.BaseFilterReader
org.apache.tools.ant.filters.BaseParamFilterReader
org.apache.tools.ant.filters.TailFilter

All Implemented Interfaces:
  `java.io.Closeable`, `java.lang.AutoCloseable`, `java.lang.Readable`, `ChainableReader`, `Parameterizable`

    public final class TailFilter
    extends BaseParamFilterReader
    implements ChainableReader

Reads the last `n` lines of a stream. (Default is last10 lines.) Example:

    <tailfilter lines="3"/>

Or:

    <filterreader classname="org.apache.tools.ant.filters.TailFilter">
       <param name="lines" value="3"/>
     </filterreader>

- ## Field Summary

  ### Fields inherited from class java.io.FilterReader

  `in`

  ### Fields inherited from class java.io.Reader

  `lock`

- ## Constructor Summary

  Constructors
  Constructor | Description
  --- | ---
  `TailFilter()` | Constructor for "dummy" instances.
  `TailFilter​(java.io.Reader in)` | Creates a new filtered reader.

- ## Method Summary

  Modifier and Type | Method | Description
  --- | --- | ---
  `java.io.Reader` | `chain​(java.io.Reader rdr)` | Creates a new TailFilter using the passed in Reader for instantiation.
  `int` | `read()` | Returns the next character in the filtered stream.
  `void` | `setLines​(long lines)` | Sets the number of lines to be returned in the filtered stream.
  `void` | `setSkip​(long skip)` | Sets the number of lines to be skipped in the filtered stream.

  ### Methods inherited from class org.apache.tools.ant.filters.BaseParamFilterReader

  `getParameters, setParameters`

  ### Methods inherited from class org.apache.tools.ant.filters.BaseFilterReader

  `getInitialized, getProject, read, readFully, readLine, setInitialized, setProject, skip`

  ### Methods inherited from class java.io.FilterReader

  `close, mark, markSupported, ready, reset`

  ### Methods inherited from class java.io.Reader

  `nullReader, read, read, transferTo`

  ### Methods inherited from class java.lang.Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- ## Constructor Details

  - ### TailFilter

    public TailFilter()
    Constructor for "dummy" instances.
    See Also:
      `BaseFilterReader()`

  - ### TailFilter

    public TailFilter​(java.io.Reader in)
    Creates a new filtered reader.
    Parameters:
      `in` - A Reader object providing the underlying stream. Must not be `null`.

- ## Method Details

  - ### read

    public int read() throws java.io.IOException
    Returns the next character in the filtered stream. If the read-ahead has been completed, the next character in the buffer is returned. Otherwise, the stream is read to the end and buffered (with the buffer growing as necessary), then the appropriate position in the buffer is set to read from.
    Overrides:
      `read` in class `java.io.FilterReader`
    Returns:
      the next character in the resulting stream, or -1 if the end of the resulting stream has been reached
    Throws:
      `java.io.IOException` - if the underlying stream throws an IOException during reading

  - ### setLines

    public void setLines​(long lines)
    Sets the number of lines to be returned in the filtered stream.
    Parameters:
      `lines` - the number of lines to be returned in the filtered stream

  - ### setSkip

    public void setSkip​(long skip)
    Sets the number of lines to be skipped in the filtered stream.
    Parameters:
      `skip` - the number of lines to be skipped in the filtered stream

  - ### chain

    public java.io.Reader chain​(java.io.Reader rdr)
    Creates a new TailFilter using the passed in Reader for instantiation.
    Specified by:
      `chain` in interface `ChainableReader`
    Parameters:
      `rdr` - A Reader object providing the underlying stream. Must not be `null`.
    Returns:
      a new filter based on this configuration, but filtering the specified reader